﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.ComponentModel;

namespace Telerik.Windows.Data
{
	/// <summary>
	/// Holds extension methods for <see cref="ItemPropertyInfo"/>.
	/// </summary>
	public static class ItemPropertyInfoExtensions
	{
		/// <exception cref="InvalidOperationException"><paramref name="itemProperty"/> descriptor is not supported.</exception>
		public static void SetValue(this ItemPropertyInfo itemProperty, object item, object value)
		{
			var info = itemProperty.Descriptor as PropertyInfo;
			if (info != null)
			{
				info.SetValue(item, value, null);
				return;
			}

			

			throw new InvalidOperationException("ItemPropertyInfo descriptor is not supported.");
		}
	}
}